# -*- coding: utf-8 -*-
"""
Created on Sun Oct 19 09:52:31 2014

@author: olive
"""
class suK:
    def __init__(self):
        self.grpList=['GLOB','SOLV','OUT','MED','SSM','ICS'] # BCS written in auto mode
        l1 = ['med.15'+s for s in ['a','b','c','d','e','f','g','h','i']]
        self.groups={
        'GLOB':['glob.1a','glob.1b','glob.2a','glob.2b','glob.3','glob.4','glob.5','glob.6a',
                'glob.6b','glob.7'],
        'SOLV':['solv.7a','solv.7b','solv.7c'],
        'OUT':['out.8a','out.8b','out.8c','out.8d','out.8e'],
        'MED':['med.9','med.10','med.11','med.12','med.13','med.14a','med.14b'],
        'SSM':['ssm.17','ssm.18','ssm.19','ssm.20','ssm.22'],
        'ICS':['ics.1','ics.2','ics.3'],
        }
        self.groups['MED'].extend(l1)
        self.lines={
        #to INP file : all major data
        'glob.1a':{'comm':'Title1','cond':'','kw':['title1'],'detail':[],'type':['title']},
        'glob.1b':{'comm':'Title2','cond':'','kw':['title2'],'detail':[],'type':['title']},
        'glob.2a':{'comm':'Model type','cond':'','kw':['sutra','version','type','transport'],
                  'detail':[['Memo','SUTRA'],
                            ['Version','VERSION 2.0','VERSION 2.1','VERSION 2.2','VERSION 2D3D.1'],
                            ['Type','SOLUTE','ENERGY'],['Memo','TRANSPORT']],
                  'type':['choice','choice','choice','choice'],
                  'default':[0,2,0,0]},
        'glob.2b':{'comm':'Mesh','cond':'','kw':['MSHSTR1','MSHSTR2','NN1','NN2','NN3'],
                  'detail':[['dimension','2D','3D'],
                            ['type','Regular','Blockwise','Layered','Irregular'],
                            'Nb of nodes 1st dim','Nb of nodes 2nd dim','Nb of nodes 3rd dim'],
                  'type':['choice','choice','int','int','int']},
        # there are additional lines if blockwise (omitted here)
        'glob.3':{'comm':'Main numbers','cond':'','kw':['NN','NE','NPBC','NUBC','NSOP','NSOU','NOBS'],
                 'detail':['Nb nodes','Nb elements','Nb Pressure BC','Nb Conc BC',
                    'Nb source Pressure','Nb source energy','Nb obs points'],
                 'type':['int','int','int','int','int','int','int']},
        'glob.4':{'comm':'Problem type','cond':'','kw':['CUNSAT','CSSFLO','CSTRA','CREAD','ISTORE'],
                 'detail':[['Saturation','Saturated','Unsaturated'],['Flow','Steady','Transient'],
                           ['Transport','Steady','Transient'],['Restart','Cold','Warm'],
                           'store each n time step'],
                 'type':['choice','choice','choice','choice','int']},
        'glob.5':{'comm':'Numerical control','cond':'','kw':['UP','GNUP','GNUU'],
                 'detail':['upstream fraction','Pressure BC conductance','Concentration BC conductance'],
                 'type':['float','float','float'],
                 'default':[0.,0.01,0.01]},
        'glob.6a':{'comm':'Temporal control','cond':'','kw':['NSCH','NPCYC','NUCYC'],
                 'detail':['Nb Schedules','n time steps for Pressure','n time steps for Conc'],
                 'type':['int','int','int'],
                 'default':[1,1,1]},
        'glob.6b':{'comm':'Schedule detail','cond':'',
                   'kw':['SCHNAM','SCHTYP','CREFT','SCALT','NTLIST','TLIST'],
                  'detail':[['name of schedule','Time_Steps'],['Schedule type','Time List'],
                  ['time count','Absolute'],'Scale factor','nb of tsteps','time list'],
                  'type':['choice','choice','choice','float','int','string'],
                  'default':[0,0,0,86400.,3,'1 3 5']},
        'glob.7':{'comm':'Options','cond':'','kw':['PINPUT','STEPDIV'],
                 'detail':[['P input','As pressure','as Head'],'Step divide'],
                 'type':['choice','int'],
                 'default':[0,10]},
        # solver
        'solv.7a':{'comm':'Iterations','cond':'','kw':['ITRMAX','RPMAX','RUMAX'],
                  'detail':['max nb of iterations','abs pressure convergence','abs conc convergence'],
                  'type':['int','float','float'],'default':[5000,1.,0.01]},
        'solv.7b':{'comm':'Solver for pressure','cond':'','kw':['CSOLVP','ITRMXP','TOLP'],
                  'detail':[['type','ORTHOMIN','GMRES','CG','DIRECT'],'max solver iteration','solver tolerance'],
                  'type':['choice','int','float'],'default':[2,1000,1e-12]},
        'solv.7c':{'comm':'Solver for concentration','cond':'','kw':['CSOLVU','ITRMXU','TOLU'],
                  'detail':[['type','ORTHOMIN','GMRES','CG','DIRECT'],'max solver iteration','solver tolerance'],
                  'type':['choice','int','float'],'default':[1,1000,1e-12]},
        # output
        'out.8a':{'comm':'Otput data','cond':'',
                  'kw':['NPRINT','CNODAL','CELMNT','CINCID','CPANDS','CVEL','CCORT','CBUDG','CSCRN','CPAUSE'],
                  'detail':['n time steps to print',['nodal coord and porosity','N','Y'],['permeability and dispersivity','N','Y'],
                  ['elmt incidence','N','Y'],['pressure and sat','N','Y'],['velocity','N','Y'],['Conc or Temp','N','Y'],['Budget','N','Y'],
                  ['print to screen','N','Y'],['pause at end of run','N','Y']],
                  'type':['int','choice','choice','choice','choice','choice','choice','choice','choice','choice'],
                  'default':[-1,0,0,0,0,0,0,0,0,0]},
        'out.8b':{'comm':'output on nodes','cond':'','kw':['NCOLPR','SUNCOL'],
                  'detail':['n time steps','column titles'],
                  'type':['int','string'],'default':[5,'\'X\' \'Y\' \'Z\' \'P\' \'U\' \'S\' \'-\'']},
        'out.8c':{'comm':'output on elements','cond':'','kw':['LCOLPR','LCOL'],
                  'detail':['n time steps','column titles'],
                  'type':['int','string'],'default':[5,'\'X\' \'Y\' \'Z\' \'VX\' \'VY\' \'VZ\' \'-\'']},
        'out.8d':{'comm':'observation output','cond':'NOBS>0','kw':['NOBLIN'],
                  'detail':['n of obs'],'type':['int'],'default':[0]},
        'out.8e':{'comm':'observation output','cond':'',
                  'kw':['NBCFPR','NBCSPR','NBCPPR','NBCUPR','CINACT'],
                'detail':['fluid src node outp','solute src node outp','pressure node outp',
                          'conc node outp',['print inact cells','N','Y']],
                'type':['int','int','int','int','choice'],
                'default':[10,10,10,10,0]},
        # medium properties
        'med.9':{'comm':'fluid properties','cond':'',
                  'kw':['COMPFL','CW','SIGMAW','RHOW0','URHOW0','DRWDU','VISC0'],
                  'detail':['fluid compressibility','Fluid specif heat','Diffusion/thermal conductivity',
                  'base density','base concentration','density/conc slope','Viscosity (or conv units)'],
                  'type':['float','float','float','float','float','float','float'],
                  'default':[1e-10,4182,0.6,1000.0,0,0,1e-3]},
        'med.10':{'comm':'matrix properties','cond':'','kw':['COMPMA','CS','SIGMAS','RHOS'],
                  'detail':['matrix compressibility','solid specific heat','thermal conductivity',
                            'solid density'],
                  'type':['float','float','float','float'],
                  'default':[0.,840,3.5,2650]},
        'med.11':{'comm':'sorption properties','cond':'','kw':['ADSMOD','CHI1','CHI2'],
                  'detail':[['type','None','Linear''Freundlich','Langmuir'],
                            '1st coefficient','2nd coefficient'],
                  'type':['choice','float','float']},
        'med.12':{'comm':'production of mass or energy','cond':'','kw':['PRODF0','PRODS0','PRODF1','PRODS1'],
                  'detail':['0order prod. in liquid','0order prod. in solid',
                            '1order prod. in liquid','1order produ. in solid'],
                  'type':['float','float','float','float']},
        'med.13':{'comm':'gravity vector','cond':'','kw':['GRAVX','GRAVY','GRAVZ'],
                  'detail':['component along X','component along Y','component along Z'],
                  'type':['float','float','float'],'default':[0,0,-9.8]},
        'med.14a':{'comm':'nodes scaling','cond':'','kw':['DUM','SCALX','SCALY','SCALZ','PORFAC'],
                  'detail':[['Memo','Node'],'scaling in X','scaling in Y','scaling in Z','porosity scaling'],
                  'type':['choice','float','float','float','float'],'default':[0,1,1,1,1]},
        'med.14b':{'comm':'porosity','cond':'','kw':['POR'],
                  'detail':['nodes porosity'],'type':['arrfloat'],'default':[0.25]},
        'med.15a':{'comm':'element scaling','cond':'',
                   'kw':['DUM','PMAXFA','PMIDFA','PMINFA','ANG1FA','ANG2FA','ANG3FA','ALMAXF','ALMIDF','ALMINF',
                         'ATMAXF','ATMIDF','ATMINF'],
                  'detail':[['Memo','Element'],'scaling Perm max','scaling Perm mid','scaling Perm min',
                            'scaling Angl1','scaling Angl2','scaling Angl3','scaling ALmax','scaling ALmid','scaling ALmin',
                            'scaling ATmax','scaling ATmid','scaling ATmin'],
                  'type':['choice','float','float','float','float','float','float','float','float','float','float','float','float'],
                  'default':[0,1,1,1,1,1,1,1,1,1,1,1,1]},
        'med.15b':{'comm':'unsaturated region','cond':'','kw':['LREG'],
                  'detail':['unsaturated region'],'type':['arrint'],'default':[1]},
        'med.15c':{'comm':'permeability dir.1','cond':'','kw':['PMAX'],
                  'detail':['perm dir.1'],'type':['arrfloat'],'default':[1e-12]},
        'med.15d':{'comm':'permeability dir.2','cond':'MSHSTR1==\'3D\'','kw':['PMID'],
                  'detail':['perm dir.2'],'type':['arrfloat'],'default':[1e-12]},
        'med.15e':{'comm':'permeability dir.3','cond':'','kw':['PMIN'],
                  'detail':['perm dir.3'],'type':['arrfloat'],'default':[1e-12]},
        'med.15f':{'comm':'anisotropy angle','cond':'','kw':['ANGLE1','ANGLE2','ANGLE3'],
                  'detail':['Angle 1','Angle 2','Angle 3'],
                  'type':['float','float','float'],'default':[0.,0.,0.]},
        'med.15g':{'comm':'dispersivity','cond':'','kw':['AL'],
                  'detail':['Longitudinal disp.'],'type':['float'],'default':[1.]},
        'med.15h':{'comm':'dispersivity','cond':'','kw':['AT'],
                  'detail':['Transverse disp.1'],'type':['float'],'default':[0.1]},
        'med.15i':{'comm':'dispersivity','cond':'MSHSTR1==\'3D\'','kw':['AT2'],
                  'detail':['Transverse disp.2'],'type':['float'],'default':[0.1]},
        #sources and sink
        'ssm.17':{'comm':'fluid sources and sink','cond':'NSOP>0','kw':['QINC'],
                  'detail':['discharge + temp or conc. values'],'type':['arrfloat']},
        'ssm.18':{'comm':'mass/energy sources and sink','cond':'NSOU>0','kw':['QUINC'],
                  'detail':['mass/energy sources'],'type':['arrfloat']},
        'ssm.19':{'comm':'Values at fixed Pressure BC','cond':'NPBC>0','kw':['PBC'],
                  'detail':['pressure + temp or conc. values'],'type':['arrfloat']},
        'ssm.20':{'comm':'Values at fixed temp/conc BC','cond':'NUBC>0','kw':['UBC'],
                  'detail':['temp. or conc. value'],'type':['arrfloat']},
        'ssm.22':{'comm':'Element incidence','cond':'','kw':['title'],'detail':[],'type':['title']},
        # ICS file initial conditions
        'ics.1':{'comm':'Starting time','cond':'','kw':['TICS'],
                  'detail':['time'],'type':['float'],'default':[0]},
        'ics.2':{'comm':'Initial pressure','cond':'','kw':['PVEC'],
                  'detail':['pressure value'],'type':['arrfloat'],'default':[0.]}, # written in a specifci way
        'ics.3':{'comm':'Initial temp/conc','cond':'','kw':['UVEC'],
                  'detail':['temp/conc value'],'type':['arrfloat'],'default':[0.]}, # written in a specifci way
        }
